apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "shiraka.name" . }}
  labels:
    {{- include "shiraka.standardLabels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "shiraka.selectorLabels" . | nindent 6 }}
      component: web
  template:
    metadata:
      labels:
        {{- include "shiraka.selectorLabels" . | nindent 8 }}
        component: web
    spec:
      {{- if .Values.podSecurityContext }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      {{- end }}
      imagePullSecrets:
        - name: {{ required "A secret containing Gitlab pull credentials is required." .Values.imagePullSecret }}
      initContainers:
        - name: set-permissions
          image: "{{ .Values.imageRepository }}:{{ .Values.imageTag }}"
          volumeMounts:
            - name: media
              mountPath: /app/storage
          command: ["/bin/sh", "-c", "chown -R www-data:www-data /app/storage"]
      containers:
        - name: {{ include "shiraka.name" . }}
          image: "{{ .Values.imageRepository }}:{{ .Values.imageTag }}"
          imagePullPolicy: IfNotPresent
          {{- if .Values.securityContext }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          {{- end }}
          envFrom:
            - secretRef:
                name: {{ include "shiraka.name" . }}
            - configMapRef:
                name: {{ include "shiraka.name" . }}
          ports:
            - name: http
              containerPort: {{ .Values.service.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /en
              port: http
            {{- toYaml .Values.livenessProbe | nindent 12 }}
          readinessProbe:
            exec:
              command:
                - /bin/sh
                - -c
                - "touch /app/storage/ready-file-$(date +%s) && rm -f /app/storage/ready-file-* && curl -f -s -o /dev/null http://localhost:{{ .Values.service.port }}/en"
            {{- toYaml .Values.readinessProbe | nindent 12 }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          volumeMounts:
            - name: media
              mountPath: /app/storage
      volumes:
        - name: media
          persistentVolumeClaim:
            claimName: {{ include "shiraka.mediaSharedStoragePvcName" . }}
